'''
decompress module, version 0.1aplha

(c) 2003 Jan ONDREJ (SAL) <ondrejj@salstar.sk>
                                                                                
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

'''

from avlib import *
import re,string,os

__all__=['decompress']

decompressors={
  '.zip':	[[ 'unzip','-P','s','-o' ]],
  '.rar':	[[ 'unrar','x','-p-','-y'], ['rar','x','-p-','-y' ]],
  '.ace':	[[ 'unace','x','-y' ]],
  '.arj':	[[ 'unarj','x','-y'], [ 'arj','x','-y' ]],
  '.zoo':	[[ 'unzoo','-x','-j'], [ 'zoo','-x','-j' ]],
  '.jar':	[[ 'unzip','-P','s','-o' ]],
  '.lzh':	[[ 'lha','xf' ]],
  '.tar':	[[ 'tar','xvf' ]],
  '.tar.gz':	[[ 'tar','xvzf' ], [ 'gzip','-d' ]],
  '.tgz':	[[ 'tar','xvzf' ]],
  '.tar.bz2':	[[ 'tar','xvjf' ], [ 'bzip2','-d' ]],
  '.bz2':	[[ 'bzip','-d','-k' ]],
  '.gz':	[[ 'gzip','-d' ]],
}

class decompress(ascanner):
  name='decompress()'
  def __init__(self,scanner):
      self.name=self.name[:-1]+scanner.name+')'
      self.scanner=scanner
      self.vir,self.ret='',[]
      self.defiles=[]
      self.rmfiles=[]
  def __del__(self):
      self.runlink(self.rmfiles)
      self.rmfiles=[]
  def runlink(self,paths):
      for dir in paths:
        if os.lstat(dir)[0] & 0x4000: # is_dir
          for file in rlistdir('',dir):
            self.runlink([os.path.join(dir,file)])
          os.rmdir(dir)
        else:
          os.unlink(dir)
  def scanfile(self,files,dir='',level=0):
      for file in files:
        extmatch=0
        for ext,progs in decompressors.items():
          if re.search(ext+'$',file,re.IGNORECASE):
            extmatch=1
            break
        if not extmatch:
          self.defiles.append(file)
        else:
          zipdir=os.path.join(dir,file+'.dir')
          os.mkdir(zipdir)
          self.rmfiles.append(zipdir)
          for arg in progs:
            try:
              pf=popen(arg+['../'+file],zipdir)
              decerr=pf.readlines()
              #pf.wait()
              os.unlink(os.path.join(dir,file))
              open(os.path.join(dir,file),'w').close()
              newfiles=rlistdir(dir,file+'.dir')
              self.scanfile(newfiles,dir,level+1)
              break
            except:
              debug(3,'decompressor failed: ',str(arg+[file]))
              debug_traceback(4,'decompressor')
      if level==0:
        vir,ret=self.scanner.scanfile(self.defiles,dir)
        self.runlink(self.rmfiles)
        self.rmfiles=[]
      else:
        vir,ret='',[]
      return vir,ret
